package com.huigou.topsun.resource.controller;

import com.huigou.topsun.resource.service.ResourceFiledService;
import com.huigou.uasp.annotation.ControllerMapping;
import com.huigou.uasp.client.CommonController;
import com.huigou.util.SDO;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Auther: xin.lu
 * @Date: 2023/10/31/9:07
 * @Description:
 */
//@Tag(name = "资源字段")
@Controller
@ControllerMapping("/resourceField")
public class ResourceFieldController extends CommonController {
    protected String getPagePath() {
        return "/biz/topsun/resource/";
    }
    @Resource
    private ResourceFiledService resourceFiledService;

    public String forwardAddResourceFieldValue(){
        SDO sdo = this.getSDO();
        String resourceTypeId = sdo.getString("resourceTypeId");
        this.putAttribute("resourceTypeId",resourceTypeId);
        return forward("fieldValueDetail");
    }

    //@Operation(summary = "根据资源类型id，查询资源字段")
    public String getResourceField(){
        SDO sdo = this.getSDO();
        Long resourceTypeId = sdo.getLong("resourceTypeId");
        return toResult(resourceFiledService.findByResourceTypeId(resourceTypeId));
    }

    //@Operation(summary = "保存资源字段值")
    public String saveResourceFiledValue(@RequestBody HashMap<String,Object> map){
        return toResult(resourceFiledService.saveResourceFiledValue(map));
    }

    //@Operation(summary = "修改资源字段值")
    public String updateResourceFiledValue(@RequestBody HashMap<String,Object> map){
        return toResult(resourceFiledService.saveResourceFiledValue(map));
    }

    //@Operation(summary = "根据资源类型id，获取资源值")
    public String getResourceFieldValue(){
        SDO sdo = this.getSDO();
        Long resourceTypeId = sdo.getLong("resourceTypeId");
        List<Map<String, Object>> resourceFieldValue = resourceFiledService.getResourceFieldValue(resourceTypeId);
        HashMap<Object, Object> map = new HashMap<>();
        map.put("Rows",resourceFieldValue);
        return toResult(map);
        //return success();
    }

    //@Operation(summary = "根据资源类型id和数据id删除资源值")
    public String deleteResourceFiledValue(@RequestParam("resourceTypeId") Long resourceTypeId, @RequestParam("id") Long id){
        return toResult(resourceFiledService.deleteResourceFieldValue(resourceTypeId,id));
    }

    public String getResourceFieldType(@RequestParam("id") Long id){
        return toResult(resourceFiledService.findById(id));
    }
}
